'use strict';

const AWS = require('aws-sdk');

class LambdaService {
  constructor(aws = AWS) {
    this.Lambda = new aws.Lambda({ region: 'us-west-2' });

    this.createAlias = this.createAlias.bind(this);
    this.listAliases = this.listAliases.bind(this);
    this.listVersionsByFunction = this.listVersionsByFunction.bind(this);
    this.updateAlias = this.updateAlias.bind(this);
  }

  createAlias(FunctionName, FunctionVersion, Name) {
    return this.Lambda.createAlias({ FunctionName, FunctionVersion, Name }).promise();
  }

  listAliases(FunctionName) {
    return this.Lambda.listAliases({ FunctionName }).promise();
  }

  listVersionsByFunction(params) {
    return this.Lambda.listVersionsByFunction(params).promise();
  }

  updateAlias(FunctionName, FunctionVersion, Name) {
    return this.Lambda.updateAlias({ FunctionName, FunctionVersion, Name }).promise();
  }
}

module.exports = LambdaService;
